PCP2JSON(1)

NAME
pcp2json - pcp-to-json metrics exporter

SYNOPSIS
pcp2json [-CGHILrvVxXz?] [-a archive] [--archive-folio folio] [-A align] [-b space-scale] [-c config] [--container container] [--daemonize] [-e derived] [-f format] [-F outfile] [-h host] [-i instances] [-K spec] [-O origin] [-P precision] [-q count-scale] [-s samples] [-S starttime] [-t interval] [-T endtime] [-y time-scale] [-Z timezone] metricspec [...]

DESCRIPTION
pcp2json is a customizable performance metrics exporter tool from PCP to JSON. Any available performance metric, live or archived, system and/or application, can be selected for exporting using either command line arguments or a configuration file.

pcp2json is a close relative of pmrep(1). Please refer to pmrep(1) for the metricspec description accepted on pcp2json command line and pmrep.conf(5) for description of the pcp2json.conf configuration file overall syntax, this page describes pcp2json specific options and configuration file differences with pmrep.conf(5).

Only the command line options listed on this page are supported, other options recognized by pmrep(1) are not supported.

Configuration file options override the corresponding built-in default values (if any). Command line options override the corresponding configuration file options (if any).

CONFIGURATION FILE
pcp2json uses a configuration file with overall syntax described in pmrep.conf(5). The following options are common with pmrep.conf: version, source, speclocal, derived, header, globals, samples, interval, type, ignore_incompat, instances, omit_flat, precision, count_scale, space_scale, time_scale. The output option is recognized but ignored for pmrep.conf compatibility.

pcp2json specific options

extended (boolean)
    Write extended information about metrics. Corresponding command line option is -x. Default is no.

everything (boolean)
    Write everything known about metrics, including PCP internal IDs. Corresponding command line option is -X. Default is no.

COMMAND LINE OPTIONS
The available command line options are:

-a  Performance metric values are retrieved from the set of Performance Co-Pilot (PCP) archive log files identified by the argument archive, which is a comma-separated list of names, each of which may be the base name of an archive or the name of a directory containing one or more archives.

--archive-folio
    Read metric source archives from the PCP archive folio (see mkaf(1)).

-A  Force the initial sample to be aligned on the boundary of a natural time unit align. Refer to PCPIntro(1) for a complete description of the syntax for align.

-b  Unit/scale for space (byte) metrics, possible values include bytes, Kbytes, KB, Mbytes, MB, and so forth up to Ebytes, EB. This option will not override possible per-metric specifications. See also pmParseUnitsStr(3).

-c  Specify the config file to use. The default is the first found of: ./pcp2json.conf, $HOME/.pcp2json.conf, $HOME/pcp/pcp2json.conf, and $PCP_SYSCONF_DIR/pcp2json.conf. For details, see the above section and pmrep.conf(5).

--container
    Fetch performance metrics from the specified container, either local or remote (see -h).

-C  Exit before reporting any values, but after parsing the configuration and metrics and printing possible headers.

--daemonize
    Daemonize on startup.

-e  Specify derived performance metrics. If derived starts with a slash (``/'') or with a dot (``.'') it will be interpreted as a derived metrics configuration file, otherwise it will be interpreted as comma-separated derived metric expressions. For details see pmLoadDerivedConfig(3) and pmRegisterDerived(3).

-f  Use the format string for formatting the timestamp. The format will be used with Python's datetime.strftime method which is mostly the same as that described in strftime(3). The default with stdout is %H:%M:%S. The default with csv is %Y-%m-%d %H:%M:%S.

-F  Specify the output file outfile.

-G  Do not include global metrics in reporting (see pmrep.conf(5)).

-h  Fetch performance metrics from pmcd(1) on host, rather than the default localhost.

-H  Do not print any headers.

-i  Report only the listed instances (if present). By default all current instances are reported. This is a global option that is used for all metrics unless a metric-specific instance definition is provided as part of a metricspec. By default metrics without instances are reported as usual, use -v to change this. Please refer to pmrep(1) for more details on this option.

-I  Ignore incompatible metrics. By default incompatible metrics (that is, their type is unsupported or they cannot be scaled as requested) will cause pcp2json to terminate with an error message. With this option all incompatible metrics are silently omitted from reporting. This may be especially useful when requesting non-leaf nodes of the PMNS tree for reporting.

-K  When fetching metrics from a local context (see -L), the -K option may be used to control the DSO PMDAs that should be made accessible. The spec argument conforms to the syntax described in __pmSpecLocalPMDA(3). More than one -K option may be used.

-L  Use a local context to collect metrics from DSO PMDAs on the local host without PMCD. See also -K.

-O  When reporting archived metrics, start reporting at origin within the time window (see -S and -T). Refer to PCPIntro(1) for a complete description of the syntax for origin.

-P  Use precision for numeric non-integer output values. The default is to use 3 decimal places (when applicable).

-q  Unit/scale for count metrics, possible values include count x 10^-1, count, count x 10, count x 10^2, and so forth from 10^-8 to 10^7. (These values are currently space-sensitive.) This option will not override possible per-metric specifications. See also pmParseUnitsStr(3).

-r  Output raw metric values, do not convert cumulative counters to rates. This option will override possible per-metric specifications.

-s  The argument samples defines the number of samples to be retrieved and reported. If samples is 0 or -s is not specified, pcp2json will sample and report continuously (in real time mode) or until the end of the set of PCP archives (in archive mode). See also -T.

-S  When reporting archived metrics, the report will be restricted to those records logged at or after starttime. Refer to PCPIntro(1) for a complete description of the syntax for starttime.

-t  The default update interval may be set to something other than the default 1 second. The interval argument follows the syntax described in PCPIntro(1), and in the simplest form may be an unsigned integer (the implied units in this case are seconds). See also the -T option.

-T  When reporting archived metrics, the report will be restricted to those records logged before or at endtime. Refer to PCPIntro(1) for a complete description of the syntax for endtime.

    When used to define the runtime before pcp2json will exit, if no samples is given (see -s) then the number of reported samples depends on interval (see -t). If samples is given then interval will be adjusted to allow reporting of samples during runtime. In case all of -T, -s, and -t are given, endtime determines the actual time pcp2json will run.

-v  Omit single-valued ``flat'' metrics from reporting when instances were requested. See -i and -I.

-V  Display version number and exit.

-x  Write extended information.

-X  Write everything known about metrics, including PCP internal IDs.

-y  Unit/scale for time metrics, possible values include nanosec, ns, microsec, us, millisec, ms, and so forth up to hour, hr. This option will not override possible per-metric specifications. See also pmParseUnitsStr(3).

-z  Use the local timezone of the host that is the source of the performance metrics, as identified by either the -h or the -a options. The default is to use the timezone of the local host.

-Z  Use timezone for the date and time. Timezone is in the format of the environment variable TZ as described in environ(7). Note that when including a timezone string in output, ISO 8601 -style UTC offsets are used (so something like -Z EST+5 will become UTC-5).

-?  Display usage message and exit.

FILES
pcp2json.conf
    pcp2json configuration file (see -c).

PCP ENVIRONMENT
Environment variables with the prefix PCP_ are used to parametrize the file and directory names used by PCP. On each installation, the file /etc/pcp.conf contains the local values for these variables. The $PCP_CONF variable may be used to specify an alternative configuration file, as described in pcp.conf(5).

SEE ALSO
mkaf(1), PCPIntro(1), pcp(1), pcp2elasticsearch(1), pcp2graphite(1), pcp2influxdb(1), pcp2xlsx(1), pcp2xml(1), pcp2zabbix(1), pmcd(1), pminfo(1), pmrep(1), __pmSpecLocalPMDA(3), pmLoadDerivedConfig(3), pmParseUnitsStr(3), pmRegisterDerived(3), pcp-archive(5), pcp.conf(5), pmns(5), pmrep.conf(5) and environ(7).